/**	$Revision: 1.22 $
	Last updated: $Date: 2002/09/25 21:18:01 $

	Copyright (C) 2000-2002 Vlad Mereuta <dizzy@users.sourceforge.net>

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef __ACCOUNTS_FORM__
#define __ACCOUNTS_FORM__

#include <PalmOS.h>

#include "Form.h"
#include "AccountsTable.h"
#include "TransactionsForm.h"
#include "PreferencesForm.h"
#include "PurgeTransForm.h"

/**	contains function to manipulate the main form of the program
	the variables are defined in the .c file (due to visibility issues ;) */
class AccountsForm : public Form 
{
public:
	/// constructor; does nothing
	AccountsForm() FORM_SECTION1;
	
private:
	///object used to add transactions
	EditTransactionForm* _edit_trans_form;
	/// object handling the preferences form
	PreferencesForm _pref_form;
	/// object handling the form used to purge transactions
	PurgeTransForm _purge_form;
	///object to handle transaction display
	TransactionsForm* _transactions_form;
	/// name of the current category
	Char cat_name[dmCategoryLength];
	/** the normal way to do this would be to declare a pointer to the object here and allocate it when the form is opened
	unfortunatelly memory management is not that straight forward for the palm.*/
	AccountsTable ac_tbl;
	/// store last known pen X position
	Int16 last_screenX;
	/// store last known pen Y position
	Int16 last_screenY;		

	/**	calculates the totals (if necessary) and draws them on the screen */
	void	displayTotals() FORM_SECTION1;

	/// reflect choice of visible accounts on popup trigger
	void updatePopupTrigger(void) FORM_SECTION1;
	
	/**	sets the balances of Income and Expense accounts to 0 */
	void resetIEAccounts() FORM_SECTION1;

	///called when key down event occurs
	Boolean handleKeyDownEvent(WChar key_id, UInt16 modifiers) FORM_SECTION1;
	///called when form open event occurs
	Boolean handleOpenEvent() FORM_SECTION1;
	/**	called when ctl select event occurs
            @param control_id id of the control for which the event was generated */
	Boolean handleCtlSelectEvent(UInt16 control_id) FORM_SECTION1;
	/**  called when a table select event occurs 
		 @param tbl_select forwarded tblSelect event data   */
	Boolean handleTblSelectEvent(tblSelect& tbl_select) FORM_SECTION1;
	/**	called when a menu event occurs */
	Boolean handleMenuEvent(UInt16 menu_item_id) FORM_SECTION1;
	/**	called when a form update event occurs 
	    @param update_code the update code signalled */
	Boolean handleUpdateEvent(UInt16 update_code) FORM_SECTION1;
	///this function is called when the form is closed
	Boolean	handleCloseEvent() FORM_SECTION1;
	///handles events generated by the pen up
	Boolean handlePenDownEvent (Int16 x_coord, Int16 y_coord) FORM_SECTION1; 
	///handles events generated by popups
	Boolean handlePopSelect (popSelect& pop_select) FORM_SECTION1;
};

#endif
