/**	$Revision: 1.19 $
	Last updated: $Date: 2002/09/20 12:21:30 $

	Copyright (C) 2000-2001 Vlad Mereuta <dizzy@users.sourceforge.net>

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef __ACCOUNTS_TABLE_H__
#define __ACCOUNTS_TABLE_H__

#include <PalmOS.h>

#include "Table.h"

/// number of pixels per indentation depth in the account tree
#define ACC_TBL_INDENT 5

/**
	the table displays a list of accounts
*/
class AccountsTable : public Table
{
  public:
	static const Int16		name_col=0;
	static const Int16		balance_col=1;	

	/// initialises the table
	AccountsTable();

	///loads data into the accounts table
	void loadData();
	
	///inits the columns in the table
	void initColumns();
	
	///overloads the method in Table
	Boolean recordIsValid(UInt16 id);

	///draws an arrow which indicates the state of the branch
	static void drawArrow (void* table,Int16 row, Int16 column, RectangleType* bounds);

	///draws a number into the specified pos of a table
	static void drawCurrency (void* table,Int16 row, Int16 column, RectangleType* bounds);

	///draws text into the specified pos of a table
	static void drawText(void* table, Int16 row, Int16 column, RectangleType* bounds);
};

#endif
