/**	$Revision: 1.5 $
	Last updated: $Date: 2003/01/29 23:56:50 $
	
	Copyright (C) 2001-2002 Vlad Mereuta <dizzy@users.sourceforge.net>

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef __CALC_FORM__
#define __CALC_FORM__

#include <PalmOS.h>
#include <FloatMgr.h>

#include "Form.h"

///class implements a calculator
class CalculatorForm : public Form
{
public:
    ///the update code used by this form to signal changes to other forms
    static const unsigned int update_code = 3;

	///initial amount to be diplayed
	Int32 amount;
	///sign of the amount memorised
	Int8 sign;

	///constructor, does nothing
	CalculatorForm() FORM_SECTION1;
	/** returns reference to SplitsForm instance. Only allowed way to use the class */
	static CalculatorForm* instance() FORM_SECTION1;

private:
	///current calculator entry
	Char entry[32];
	///text for decimal separator
	Char dotLabel[2];
	FlpCompDouble accu;
	FlpCompDouble operand;
	Char operation;
	Boolean disp_accu;
	///singleton reference to this form	
	static CalculatorForm* _instance;
	
	///updates calculator display display
	void updateDisplay() FORM_SECTION1;
	///redraws form and update display
	Boolean handleUpdateEvent(UInt16 update_code) FORM_SECTION1;
	///draws initial calculator
	Boolean handleOpenEvent() FORM_SECTION1;
	///handles all control interaction
	Boolean handleCtlSelectEvent (UInt16 control_id) FORM_SECTION1;
	///update entry with information from a button
	void handleButton(Char c) FORM_SECTION1;
	///carry out operation
	void doMath(Char newop) FORM_SECTION1;
	///flip sign
	void flipSign(void) FORM_SECTION1;
};
#endif
