/** $Revision: 1.14 $
    Last updated: $Date: 2002/09/20 12:21:30 $

    Copyright (C) 2001-2002 Vlad Mereuta <dizzy@users.sourceforge.net>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef __CHOOSE_ACCOUNT_FORM__
#define __CHOOSE_ACCOUNT_FORM__

#include <PalmOS.h>
#include "Form.h"

#include "FreeCoinsRsc.h"

/**  This class displays a form which enables the user to choose an account from a displayed account list */
class ChooseAccountForm : public Form
{	
public:
	///if true the form will allow the user to click ok without making a selection (for selecting catogories and/or the account currently explored)
	bool allow_no_selection;
	///allow creation of new account from this dialog
	bool allow_new_account;
	///choosen account
	UInt32	chosen_account;
	///true if an account was chosen
	bool chosen;

	/**  constructor; sets form variables */
	ChooseAccountForm() FORM_SECTION1;
	///returns singleton reference to this object
	static ChooseAccountForm* instance() FORM_SECTION1;	

	///initialises form
	Boolean handleOpenEvent() FORM_SECTION1;
	///handles controls
	Boolean handleCtlSelectEvent (UInt16 control_id) FORM_SECTION1;
	///handles key presses
	Boolean handleKeyDownEvent(WChar key_id, UInt16 modifiers) FORM_SECTION1;
	///handle updates
	Boolean handleUpdateEvent (UInt16 update_code) FORM_SECTION1;
	/// callback for custom list drawing 
	static void drawAccountName(Int16 itemNum, RectangleType *bounds, Char **txt) FORM_SECTION1;

private:
	///reference to this object
	static ChooseAccountForm* _instance;
};

#endif
