/**	$Revision: 1.14 $
	Last updated: $Date: 2002/09/09 15:35:29 $
	
	Copyright (C) 2000-2002 Vlad Mereuta <dizzy@users.sourceforge.net>

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#include "CoinsPref.h"

#include <Preferences.h>
#include <DateTime.h>

#include "AccountsDB.h" //to be able to manipulate the totals structure

CoinsPref::CoinsPref()
{
	id = 0;	//id for the pref structure above
	ver = 3;
	//load the application preferences
	read();	
}

CoinsPrefType* CoinsPref::get()
{
	return &coins_pref;
}

void CoinsPref::read()
{
	UInt16 t=sizeof(coins_pref);
	int ret=PrefGetAppPreferences(FREE_COINS_CREATOR,id,(void*) &coins_pref,&t,true);
	
	if (ret==noPreferenceFound) {
		setDefault();
		save();
	}
}

void CoinsPref::save()
{
	PrefSetAppPreferences(FREE_COINS_CREATOR,id,ver,(void*) &coins_pref,sizeof(coins_pref),true);
}

void CoinsPref::setDefault()
{
	//set the last update to yesterday
	DateType today;

	//get today's date
	DateSecondsToDate(TimGetSeconds(),& today);
	
	//store yesterday in today
	DateAdjust(&today,-1);
	coins_pref.payment_method = pm_card;
	coins_pref.last_update=today;
	coins_pref.visible_acc_types = 0;
	coins_pref.displayed_balance=0;
	coins_pref.disp_payee=false;
	coins_pref.disp_cleared_col=true;
	coins_pref.reserved = 0;
	coins_pref.remember_trans_view=false;
	coins_pref.trans_view=0;
	coins_pref.def_acc = 0;
	coins_pref.def_currency = 0;
	coins_pref.trans_cleared = false;
	coins_pref.use_thousands_sep = false;
    coins_pref.check_pass = false;
    coins_pref.inc_children_total = false;
}

CoinsPref preferences;
