/** $Revision: 1.4 $
    Last updated: $Date: 2002/09/24 19:46:42 $

    Copyright (C) 2002 Vlad Mereuta <dizzy@users.sourceforge.net>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#include "CurrencyListForm.h"
#include "CurrencyDB.h"
#include "CoinsPref.h"

CurrencyListForm* CurrencyListForm::_instance = NULL;
CurrencyListForm currency_list_form;

CurrencyListForm::CurrencyListForm() : Form (CURRENCY_LIST_FORM)
{}

CurrencyListForm* CurrencyListForm::instance()
{
	if(_instance == NULL) {
		_instance = &currency_list_form;
	}
	return _instance;
}	

void CurrencyListForm::drawCurrencyEntry(Int16 item_no, RectangleType* bounds, Char** txt)
{
	Char list_entry[80];

	currency_db->getDescriptionTruncLeftToFit(currency_db->getRecordUid(item_no), bounds->extent.x, list_entry);
	WinDrawChars(list_entry, StrLen(list_entry),bounds->topLeft.x, bounds->topLeft.y);
}

Boolean CurrencyListForm::handleOpenEvent()
{
	_list= reinterpret_cast<ListPtr>(GetObjectPtr(CURRENCY_LIST));
	LstSetDrawFunction(_list, drawCurrencyEntry);
	handleUpdateEvent (0);
	return true;
}

Boolean CurrencyListForm::handleUpdateEvent (UInt16 update_code)
{	
	LstSetListChoices(_list, NULL, DmNumRecordsInCategory(currency_db->getRef(), dmAllCategories));
	LstSetSelection (_list, noListSelection);	
	
	if (preferences.get()->def_currency != 0) {
		currencyStructure cs;
		currency_db->getUnpackedRecord (preferences.get()->def_currency, &cs);
		FrmHideObject (frm, getObjectIndex (CURRENCY_DEF_LABEL));
		FrmCopyLabel (frm, CURRENCY_DEF_LABEL, cs.code);
		FrmShowObject (frm, getObjectIndex (CURRENCY_DEF_LABEL));
	}
	FrmDrawForm (frm);

	return true;
}

Boolean CurrencyListForm::handleLstSelectEvent(UInt16 item)
{
	edit_currency_form.setRecordIsNew (false);
	currency_db->selectRecord (item);
	popup (&edit_currency_form);
	return true;
}

Boolean CurrencyListForm::handleCtlSelectEvent(UInt16 control_id)
{
	switch(control_id) {
		case CURRENCY_OK: {
			FrmUpdateForm(caller_form_id,0);		
			FrmReturnToForm(0);
			break;
		}
		case CURRENCY_NEW:
			edit_currency_form.setRecordIsNew (true);
			popup (&edit_currency_form);
			break;
		default:
			return false;
	};
	return true;
}

Boolean CurrencyListForm::handleKeyDownEvent(WChar key_id, UInt16 modifiers)
{
	ListPtr list= reinterpret_cast<ListPtr>(GetObjectPtr(CURRENCY_LIST));

	switch (key_id) {
		case pageUpChr:
			LstScrollList(list, winUp, 9);
			break;		
		case pageDownChr:
			LstScrollList(list, winDown, 9);
			break;
		default:
			return false;
	}
	return true;
}
