/** $Revision: 1.3 $
    Last updated: $Date: 2002/09/20 12:21:30 $

    Copyright (C) 2002 Vlad Mereuta <dizzy@users.sourceforge.net>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef __CURRENCY_LIST_FORM__
#define __CURRENCY_LIST_FORM__

#include <PalmOS.h>

#include "Form.h"
#include "EditCurrencyForm.h"
#include "FreeCoinsRsc.h"

/**  This class displays a form which enables the user to browse all entries in the currency database. The form also displays
     the default currency and allows for creation of new currency entries*/
class CurrencyListForm : public Form
{	
public:
	/**  constructor; sets form variables */
	CurrencyListForm() FORM_SECTION1;
	///returns singleton reference to this object
	static CurrencyListForm* instance() FORM_SECTION1;	

	/// callback for custom list drawing 
	static void drawCurrencyEntry(Int16 item_no, RectangleType* bounds, Char** txt) FORM_SECTION1;

	///handle updates (made public so that we can force the update)
	Boolean handleUpdateEvent (UInt16 update_code) FORM_SECTION1;

private:
	///reference to this object
	static CurrencyListForm* _instance;
	///pointer to list displaying currency entries
	ListPtr _list;
	
	///object used to create/edit currencies
	EditCurrencyForm edit_currency_form;

	///initialises form
	Boolean handleOpenEvent() FORM_SECTION1;
	/** handles selection of list items (pops up edit dialog)
		@param item item that has been selected */
	Boolean handleLstSelectEvent(UInt16 item) FORM_SECTION1;
	
	///handles controls
	Boolean handleCtlSelectEvent (UInt16 control_id) FORM_SECTION1;
	///handles key presses
	Boolean handleKeyDownEvent(WChar key_id, UInt16 modifiers) FORM_SECTION1;
};

#endif
