/**	$Revision: 1.4 $
	Last updated: $Date: 2002/09/20 12:21:31 $

	Copyright (C) 2002 Vlad Mereuta <dizzy@users.sourceforge.net>

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef __EDIT_CURRENCY_FORM__
#define __EDIT_CURRENCY_FORM__

#include <PalmOS.h>

#include "Form.h"
#include "CurrencyDB.h"

/** Form used to edit currency entries */
class EditCurrencyForm : public Form
{	
public:
	///constructor; initializes form
	EditCurrencyForm() FORM_SECTION1;
	/** instructs the form to treat the upcoming session as new or edit
		@param b if true, a new record is going to be created */
	void setRecordIsNew(Boolean b) { _record_is_new = b; }
private:
	///holds data being edited
	currencyStructure _currency;
	///true if the record being edited is a new record
	bool _record_is_new;
    ///handle to the currently edited currency
	MemHandle _currency_handle;
	///buffer holding the text for the conversion rate
	Char _rate_buffer[20];

	///checks validity of user data
	Boolean checkData() FORM_SECTION1;
	///saves the data introduced
	void saveData() FORM_SECTION1;
	///sets up form, fills in fields (if edit mode)
	Boolean handleOpenEvent() FORM_SECTION1;
	///handles all control actions
	Boolean handleCtlSelectEvent (UInt16 control_id) FORM_SECTION1;
};

#endif
