/**	$Revision: 1.3 $
	Last updated: $Date: 2002/09/20 12:21:31 $

	Copyright (C) 2002 Vlad Mereuta <dizzy@users.sourceforge.net>

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef __EDIT_RATE_FORM__
#define __EDIT_RATE_FORM__

#include <PalmOS.h>

#include "Form.h"

/** Form used to edit the content of a split */
class EditRateForm : public Form
{	
public:
	///structure in which data is returned
	typedef struct {
		///amount in pence of source currency
		Int32 src_amount;
		///original sign of the source amount
		bool is_src_negative;
		///amount in pence of destination currency
		Int32 dest_amount;
		///original sign of the destination amount
		bool is_dest_negative;
		///exchange rate of the transaction
		double exchange_rate;
		///if true the other values of the structure should be read and the dirty bit should be set to false
		bool dirty;
	} Results;
	
	///holds current working data and is accessible from outside the class for reading other data
	Results results;
	
	///constructor; initializes form
	EditRateForm() FORM_SECTION1;
	/**  initializes the form data to start a new session
		 @param src UID of source currency record
		 @param dest UID of destination currency record
		 @note you also need to set the fields of the results structure directly, before poping up this form */
	void initForm (UInt32 src, UInt32 dest) FORM_SECTION1;

private:
	///text for exchange rate display
	char _rate_buffer[30];
	///text for code label of source currency
	char* _src_currency_label;
	///text for code label of destination currency
	char* _dest_currency_label;
	///UID of source currency record
	UInt32 _src_currency;
	///UID of destination currency record
	UInt32 _dest_currency;

	///checks validity of user data
	Boolean checkData() FORM_SECTION1;
	///saves the data introduced
	void saveData() FORM_SECTION1;
	///sets up form, fills in fields (if edit mode)
	Boolean handleOpenEvent() FORM_SECTION1;
	///handles all control actions
	Boolean handleCtlSelectEvent (UInt16 control_id) FORM_SECTION1;
};

#endif
