/**	$Revision: 1.13 $
	Last updated: $Date: 2002/09/20 12:21:31 $
	
	Copyright (C) 2000-2002 Vlad Mereuta <dizzy@users.sourceforge.net>

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef __EDIT_SCHEDULED_TRANS_FORM__
#define __EDIT_SCHEDULED_TRANS_FORM__

#include <PalmOS.h>

#include "Form.h"
#include "TransactionsDB.h"

/** the form is used to create a new scheduled transaction or to modify an existing one, depending on the record_is_new member
   \todo automatically update the scheduled list on exit
*/
class EditScheduledTransForm : public Form
{
 private:
    ///pointer received from the EditTransactionForm. should point to the date field of the current transaction
	DateType	*start_date;
         
   ///string holding the displayable text for start date
	Char		start_date_txt[dateStringLength];
   ///string holding the displayable text for end date
	Char		end_date_txt[dateStringLength];
		
	/// the current scheduled data
	scheduledStructure* st;
	/// this is set to true if we want to create a new account and to false if we want the 'details' functionality
	Boolean record_is_new;
	
 public:
	///constructor; does nothing
	EditScheduledTransForm() FORM_SECTION2;
	
	///sets the value of the record_is_new attribute
	void setRecordIsNew(Boolean b) FORM_SECTION2;
   
   /** Starts a new session. Receives a new pointer and sets the saved state to false. It also sets
	   record_is_new to true
	   @param s pointer to a scheduledStructure where data is to be written */
	void newSession(scheduledStructure* s, DateType* trans_date) FORM_SECTION2;
   
	///saves the transaction data and updates all the accounts involved
	Boolean save() FORM_SECTION2;

	///set the values for some of the fields in the form (from the transaction record)
	void setDefaults() FORM_SECTION2;

	/**	sets the repetition interval for the transaction (both on-screen and in the structure)
		@param interval new interval */
	void setInterval(Repeat_interval interval) FORM_SECTION2;

	/** records a scheduled transaction, giving the option of altering the next date or not */
	void recordNow() FORM_SECTION2;

	///draws form and sets default values
	Boolean handleOpenEvent() FORM_SECTION2;

	/// event handler for controls in  the form
	Boolean handleCtlSelectEvent(UInt16 control_id) FORM_SECTION2;
};
#endif
