/**	$Revision: 1.7 $
	Last updated: $Date: 2002/09/25 21:18:01 $

	Copyright (C) 2000-2002 Vlad Mereuta <dizzy@users.sourceforge.net>

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef __EDIT_SPLIT_FORM__
#define __EDIT_SPLIT_FORM__

#include <PalmOS.h>

#include "Form.h"

/** Form used to edit the content of a split */
class EditSplitForm : public Form
{
public:
	///id of split in the transaction (255 if split is new)
	UInt8 split_index;
	
	///constructor; initializes form
	EditSplitForm() FORM_SECTION2;

private:
	///name of the account involced in the split
	Char acc_name[50];
	///text displayed for debit split
	Char debit_label[32];
	///text displayed for credit split
	Char credit_label[32];
	///uid of the account for the split
	UInt32 acc_uid;
	///amount for the split
	Int32 amount;
	///true if split is debit
	Boolean is_debit;

	///checks validity of user data
	Boolean checkData() FORM_SECTION2;
	///saves the data introduced
	void saveData() FORM_SECTION2;
	///sets up form, fills in fields (if edit mode)
	Boolean handleOpenEvent() FORM_SECTION2;
	///handles all control actions
	Boolean handleCtlSelectEvent (UInt16 control_id) FORM_SECTION2;
	///handles form updating
	Boolean handleUpdateEvent(UInt16 update_code) FORM_SECTION2;
};

#endif
