/**	$Revision: 1.6 $
	Last updated: $Date: 2002/09/20 12:21:31 $
	
	Copyright (C) 2000-2002 Vlad Mereuta <dizzy@users.sourceforge.net>

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef __FREE_COINS__
#define __FREE_COINS__

#include <PalmOS.h>
#include "MiscFunc.h"

/** loads form resources and sets the event handler for the form loaded.
	returns true if the event was handled and should not be passed
	to a higher level handler. */
static Boolean ApplicationHandleEvent( EventPtr event );

/** The main event loop of the application 
	normally a C application would do something like
	  FrmDispatchEvent(&event);
   but dispatch only tries to call the registered form handler and then
   frmhandleEvent, if that fails. And this is what we replicate with our own
   dispatch event which is aware of the Form class structure
*/
static void ApplicationEventLoop(void);

/** Called when the application starts/stops */
static void StartApplication(void);

/** Called when the application stops */
static void StopApplication(void);

#endif
