/**	
	$Revision: 1.5 $
	Last updated: $Date: 2002/06/14 23:10:19 $
	
	Copyright (C) 2001 Vlad Mereuta <dizzy@users.sourceforge.net>

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	$Log: GenericInputForm.cpp,v $
	Revision 1.5  2002/06/14 23:10:19  dizzy
	Form interaction now handled by FormManager
	
	Revision 1.4  2001/12/25 11:38:09  dizzy
	Form code tide up
	
	Revision 1.3  2001/09/28 00:53:29  chaese
	give focus to entry field so the user doesn't have to tap it
	
	Revision 1.2  2001/08/31 23:06:43  dizzy
	More form related tweaks
	
	Revision 1.1  2001/08/31 20:50:55  dizzy
	New form managment class
	
*/

#include "GenericInputForm.h"
#include "FormManager.h"
#include "FreeCoinsRsc.h"


GenericInputForm::GenericInputForm(Char* title, Char* text, Char* field_text, UInt8 max_field_size) :
	Form(GENERIC_INPUT_FORM)
{
	this->title = title;
	this->text = text;
	this->buf = field_text;
	this->max_field_size = max_field_size;
}

UInt16 GenericInputForm::doDialog(FormPtr parent_form)
{ 	
    //for dialogs we have to take care of load/close ourselves
    handleLoadEvent();
    
    //set the custom elements
    FrmSetTitle(frm,title);
    FrmCopyLabel(frm,GENERIC_INPUT_LABEL,text);

	// save the user one tap
	FrmSetFocus(frm, FrmGetObjectIndex(frm, GENERIC_INPUT_FIELD));

    UInt16 rez = FrmDoDialog(frm);
    //remap the buttons to true/false instead of the button ids
    rez= (rez == GENERIC_INPUT_OK);
    if (rez) {
        Char* entered_text;
        entered_text=(Char*) GetTextPtr(GENERIC_INPUT_FIELD);
        if(!entered_text) entered_text = "";
        StrNCopy(buf,entered_text,max_field_size);
    }        
        
    handleCloseEvent();
    //only setactiveform if the form given is not null
    if(parent_form) FrmSetActiveForm(parent_form);
    return rez;
}
