/**	$Revision: 1.4 $
	Last updated: $Date: 2002/09/20 12:21:31 $
	
	Copyright (C) 2001-2002 Vlad Mereuta <dizzy@users.sourceforge.net>

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef __GENERIC_INPUT_FORM__
#define __GENERIC_INPUT_FORM__

#include <PalmOS.h>
#include "Form.h"

///the form is used as a generic one field input form
class GenericInputForm : public Form
{  
public:
	/**  executes the dialog
		 @param parent_form if set it will set the active form to the given form pointer */
	UInt16      doDialog(FormPtr parent_form=NULL) FORM_SECTION2;
         
	/** Constructor
		@param title pointer to the title of the form
		@param text pointer to the text of the label
		@param field_text pointer to the string where the introduced characters are to be stored (maximum 255 characters)
		@param max_field_size the allocated/expected size of field_text*/
	GenericInputForm(Char* title, Char* text, Char* field_text, UInt8 max_field_size) FORM_SECTION2;

private:
	///pointer to the form title
	Char* title;
	///pointer to the text contained in the label (up to 255 characters)
	Char* text;
	///pointer to a buffer where the input will be stored
	Char* buf;
	///maximum allowed size for the input
	UInt8  max_field_size;
};
#endif
