/**	$Revision: 1.21 $
	Last updated: $Date: 2002/08/13 16:09:30 $
	
	Copyright (C) 2000-2002 Vlad Mereuta <dizzy@users.sourceforge.net>

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#include "PreferencesForm.h"

#include "MiscFunc.h"
#include "CoinsPref.h"
#include "FreeCoinsRsc.h"
#include "TransactionsDB.h"
#include "AccountsDB.h"
#include "ChooseAccountForm.h"

//defines for saving and retrieving checkboxes
#define SAVE_CBX(var,id) \
	prefs->var = FrmGetControlValue(frm,FrmGetObjectIndex(frm,id))
#define READ_CBX(var,id) \
	FrmSetControlValue(frm,FrmGetObjectIndex(frm,id),preferences.get()->var);


PreferencesForm::PreferencesForm() : Form (PREF_FORM)
{
	prefs=preferences.get();
}

Boolean PreferencesForm::handleUpdateEvent(UInt16 update_code)
{
	if(ChooseAccountForm::instance()->chosen) {
		ChooseAccountForm::instance()->chosen = false;
		acc_uid = ChooseAccountForm::instance()->chosen_account;					
		accounts_db->getFullNameTruncLeftToFit(acc_uid, 100, acc_name);
		CtlSetLabel((ControlType*) GetObjectPtrByForm(FrmGetActiveForm(),PREF_DEF_ACC),acc_name);
	}
	if (!osVerGe(palmos_3_5)) FrmEraseForm(frm);
	FrmDrawForm(frm);

	return true;
}

Boolean PreferencesForm::handleOpenEvent()
{
	//draw form
	READ_CBX(displayed_balance, PREF_EXPECTED_COL_CBX);
	READ_CBX(disp_cleared_col, PREF_CLEARED_CBX);
	READ_CBX(trans_cleared, PREF_DEF_CLEARED_CBX);
	READ_CBX(use_thousands_sep, PREF_THOUSAND_SEP_CBX);
	READ_CBX(check_pass,PREF_CHECK_PASS_CBX);
	READ_CBX(inc_children_total,PREF_INC_CHILD_TOTAL_CBX);
        
	PopupListSetSelection(PREF_TRANS_VIEW_LIST, PREF_TRANS_VIEW_TRIGGER,
						  (prefs->remember_trans_view) ?
						  0 : (prefs->trans_view+1) );

	PopupListSetSelection(PREF_METHOD_LIST, PREF_METHOD_TRIGGER,prefs->payment_method);	
	acc_uid = prefs->def_acc;
	if(acc_uid == 0) {
		MemHandle str_handle = DmGetResource (strRsc,NOT_SET_STR);
		StrCopy(acc_name,reinterpret_cast<char*> (MemHandleLock (str_handle)));
		MemHandleUnlock (str_handle);
		DmReleaseResource (str_handle);
	} else {
		accounts_db->getFullNameTruncLeftToFit( acc_uid, 100, acc_name);
	}
	CtlSetLabel((ControlType*) GetObjectPtrByForm(FrmGetActiveForm(),PREF_DEF_ACC),acc_name);
	
	FrmDrawForm(frm);
	return true;
}

Boolean PreferencesForm::handleCtlSelectEvent(UInt16 control_id)
{
	UInt16 temp_view;
	Boolean handled;

	switch(control_id) {
	case PREF_OK:
		SAVE_CBX(displayed_balance, PREF_EXPECTED_COL_CBX);
		SAVE_CBX(disp_cleared_col, PREF_CLEARED_CBX);
		SAVE_CBX(trans_cleared, PREF_DEF_CLEARED_CBX);
		SAVE_CBX(use_thousands_sep, PREF_THOUSAND_SEP_CBX);
		SAVE_CBX(check_pass,PREF_CHECK_PASS_CBX);
		SAVE_CBX(inc_children_total,PREF_INC_CHILD_TOTAL_CBX);
                
		if(prefs->check_pass) {
			if(!PwdExists()) {
				MemHandle str_handle = DmGetResource (strRsc,PASS_REMIND_STR);
				FrmCustomAlert(GENERIC_INFO,reinterpret_cast<char*> (MemHandleLock (str_handle)),NULL,NULL);
				MemHandleUnlock (str_handle);
				DmReleaseResource (str_handle);
			}
		}
         
		temp_view=LstGetSelection((ListPtr) GetObjectPtr(PREF_TRANS_VIEW_LIST));
		prefs->def_acc = acc_uid;
		prefs->payment_method = (Payment_method) LstGetSelection((ListPtr) GetObjectPtr(PREF_METHOD_LIST));
		
		if(!temp_view) {
			prefs->remember_trans_view=true;
		} else {
			prefs->remember_trans_view=false;
			prefs->trans_view = temp_view - 1;
		}
				
		//we know where we have been called from
		handled = true;				
		FrmUpdateForm(caller_form_id,0);
		FrmReturnToForm(0);
		break;
			
	case PREF_CANCEL:
		//cancel button was pressed;
		//simply return to the main form
		handled = true;
		FrmUpdateForm (caller_form_id,2);
		FrmReturnToForm(0);
		break;
				
	case PREF_DEF_ACC:
		handled = true;
		ChooseAccountForm::instance()->allow_no_selection = false;	
		ChooseAccountForm::instance()->chosen = false;	
		ChooseAccountForm::instance()->chosen_account = acc_uid;	
		popup(ChooseAccountForm::instance());
		break;

	default:
		handled = false;
	};
	return handled;
}

