/**	$Revision: 1.13 $
	Last updated: $Date: 2002/09/20 12:21:31 $
	
	Copyright (C) 2000-2002 Vlad Mereuta <dizzy@users.sourceforge.net>

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef __PREFERENCES_FORM__
#define __PREFERENCES_FORM__

#include <PalmOS.h>
#include "Form.h"
#include "CoinsPref.h"

/**  contains functions and variabile definitions to manipulate the Prefereces Form.
	 Preferences altered by this object are saved by StopApplication */
class PreferencesForm : public Form
{	
private:
	///the name of the currently chosen default account
	Char	acc_name[50];
	///account uid for the currently chosen default account
	UInt32	acc_uid;
	///pointer to the FreeCoins preferences bloc
	CoinsPrefType* prefs;

public:
	/**  constructor */
	PreferencesForm() FORM_SECTION2;

	///handles updates
	Boolean handleUpdateEvent(UInt16 update_code) FORM_SECTION2;
	///handles form initialisation and drawing
	Boolean handleOpenEvent() FORM_SECTION2;
	/** handles control events
		@param control_id id of the control which has received an event */
	Boolean handleCtlSelectEvent(UInt16 control_id) FORM_SECTION2;
};
#endif
