/**	$Revision: 1.4 $
	Last updated: $Date: 2002/09/24 19:46:42 $
	
	Copyright (C) 2000-2001 Vlad Mereuta <dizzy@users.sourceforge.net>

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#include "Table.h"
#include "MiscFunc.h" //for getobjptr

void Table::setRowsUnusable(UInt16 start)
{
	for(UInt16 i=start;i<rows;i++)
		TblSetRowUsable(_table,i,false);		
}

void Table::unhighlight()
{
	TblUnhighlightSelection(_table);
}

Boolean Table::pageUp()
{
	if(top_visible_item) {
		if(top_visible_item>=rows) top_visible_item-=rows-1;
		else top_visible_item=0;
		return true;
	}	
	return false;
}

Boolean Table::pageDown()
{
	if(total_items>rows) {					
		if(top_visible_item+rows+1<total_items) top_visible_item+=rows-1;
		else top_visible_item=total_items-rows;
		return true;
	}
	return false;	
}

void Table::initTable()
{
	//init globals
	_table=(TablePtr) GetObjectPtr(_table_resource);
	ErrFatalDisplayIf(!_table, "table is null!!!");

	//get max number of visible rows
	rows = TblGetNumberOfRows(_table);	

	top_visible_item=0;
	loadData();
}

Table::Table(UInt32 _table_resource, UInt32 up, UInt32 down)
{
	this->_table_resource=_table_resource;
	_up_arrow=up;
	_down_arrow=down;
	_table = NULL;
	_form = NULL;
}


Table::~Table()
{}

void Table::hideScrollArrows()
{
	CtlSetEnabled((ControlPtr) GetObjectPtr(_up_arrow),false);
	CtlSetEnabled((ControlPtr) GetObjectPtr(_down_arrow),false);
	CtlHideControl((ControlPtr) GetObjectPtr(_up_arrow));
	CtlHideControl((ControlPtr) GetObjectPtr(_down_arrow));	
}

void Table::showScrollArrows()
{
    Boolean enableUp = false, enableDown = false;
	_form = FrmGetActiveForm();

    if ((total_items > rows) || top_visible_item) {
    	// first element is not 0, hence we can scroll up
        if (top_visible_item)
            enableUp = true;
        
		// enable scrolling down if there are enough elements
        if ((top_visible_item+rows) < total_items)
            enableDown = true;
    }
	FrmUpdateScrollers(_form, FrmGetObjectIndex(_form, _up_arrow),
		FrmGetObjectIndex(_form, _down_arrow), enableUp, enableDown);
}
