/**	$Revision: 1.10 $
	Last updated: $Date: 2002/09/20 12:21:31 $
	
	Copyright (C) 2000-2002 Vlad Mereuta <dizzy@users.sourceforge.net>

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */


#ifndef __TRANSACTIONS_TABLE__
#define __TRANSACTIONS_TABLE__

#include <PalmOS.h>
#include "Table.h"

class TransactionsTable : public Table 
{
public:
	///code for the date column
	static const Int16	date_col=0;
	///code for the peer name/destination account column
	static const Int16	dest_col=1;
	///code for the amount column
	static const Int16	amount_col=2;
 	///code for the column displaying the cleared status
	static const Int16	cleared_col=3;

	/// initialises the table
	TransactionsTable();

	///loads data into the accounts table
	void loadData();
	
	///inits the columns in the table
	void initColumns();
	
	///overloads the method in Table
	Boolean recordIsValid(UInt16 id);

	///draws a sum of money (callback)
	static void drawCurrency(void* table, Int16 row, Int16 column, RectangleType* bounds);

	///draws a date (callback)
	static void drawDate(void* table, Int16 row, Int16 column, RectangleType* bounds);

	///draw the account name (source or dest; the one which is different from the present account) - callback
	static void drawAcc(void* table, Int16 row, Int16 column, RectangleType* bounds);
};

#endif
